// START LICENSE
// JSet - a Java JSet card board game implementation
// Copyright (C) 2004 Jerome Lacoste
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// END LICENSE

package org.cb.cardboard;

import javax.swing.event.ListSelectionEvent;

/**
 * An event that characterizes a change in the current
 * selection.
 * BoardSelectionListeners will generally query the source of
 * the event for the new selected status of each potentially
 * changed card.
 * <p>
 * @author jerome@coffeebreaks.org - last modified by $LastChangedBy: jerome $
 * @version $Id: BoardSelectionEvent.java 129 2004-04-15 05:00:43Z jerome $
 * @see org.cb.cardboard.BoardSelectionModel
 */
public class BoardSelectionEvent extends ListSelectionEvent
{
  /**
   * Represents a change in selection status for the specified <code>indexes</code>.
   *
   * @param source the object that changed
   * @param index the index that changed
   * @param isAdjusting an indication that this is one of rapid a series of events
   */
  public BoardSelectionEvent(final Object source, final int index, final boolean isAdjusting)
  {
    super(source, index, index, isAdjusting);
  }
}
