// START LICENSE
// JSet - a Java JSet card board game implementation
// Copyright (C) 2004 Jerome Lacoste
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// END LICENSE

package org.cb.jset;

import java.util.Stack;

/**
 * FIXME document
 * Maybe should be called CardDeck.
 * @author jerome@coffeebreaks.org - last modified by $LastChangedBy: jerome $
 * @version $Id: CardStack.java 78 2004-04-13 04:25:57Z jerome $
 */
public class CardStack
{
  private final Stack _cardStack = new Stack();

  public CardStack()
  {
    _cardStack.setSize(CardProperties.CARDSNB);
  }

  public void shuffle()
  {
    // create a stack of shuffle cards
    final boolean[] usedIndexes = new boolean[CardProperties.CARDSNB];
    for (int i = 0; i < CardProperties.CARDSNB; i++)
    {
      int randIdx = (int) (Math.random() * CardProperties.CARDSNB);
      // skip used cards
      while (usedIndexes[randIdx] == true)
      {
        randIdx++;
        if (randIdx == CardProperties.CARDSNB)
        {
          randIdx = 0;
        }
      }
      usedIndexes[randIdx] = true;
      final CardProperties prop = CardProperties.getCard(i);
      org.cb.util.Assert.assertTrue(randIdx < CardProperties.CARDSNB && randIdx >= 0, "Wrong Idx=" + randIdx);
      _cardStack.set(randIdx, prop);
    }
  }

  public CardProperties[] pop(final int nbCardsToPop)
  {
    final CardProperties[] cardsToPop = new CardProperties[nbCardsToPop];
    for (int i = 0; i < nbCardsToPop; i++)
    {
      cardsToPop[i] = (CardProperties) _cardStack.pop();
    }
    return cardsToPop;
  }

  public boolean empty()
  {
    return _cardStack.empty();
  }

  public int size()
  {
    return _cardStack.size();
  }
}
