// START LICENSE
// JSet - a Java JSet card board game implementation
// Copyright (C) 2004 Jerome Lacoste
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// END LICENSE

package org.cb.jset;

import org.cb.cardboard.Card;

import java.io.Serializable;

/**
 * An implementation of a Card for the game.
 *
 * Instances are immutable as they simply wraps a <code>CardProperties</code> instance. 
 * @author jerome@coffeebreaks.org - last modified by $Author: jerome $
 * @version $Id: JSetCard.java 129 2004-04-15 05:00:43Z jerome $
 */
public class JSetCard implements Card, Serializable
{
  private final CardProperties _properties;
//  private boolean _selected = false;

  public JSetCard(final CardProperties properties)
  {
    _properties = properties;
  }

  public CardProperties getProperties()
  {
    return _properties;
  }

//  public void select(boolean select)
//  {
//    if (select != _selected)
//    {
//      _selected = select;
//      int type = _selected ? CardEvent.SELECTED : CardEvent.DESELECTED;
//      fireCardEvent(new CardEvent(type, this));
//    }
//  }
//
  public boolean equals(final Object o)
  {
    if (this == o) return true;
    if (!(o instanceof JSetCard)) return false;

    final JSetCard card = (JSetCard) o;

    if (!_properties.equals(card._properties)) return false;

    return true;
  }

  public int hashCode()
  {
    return _properties.hashCode();
  }

  // /  private List _cardListeners = new ArrayList();
//



//  public boolean addCardListener(SetGameClientCardListener listener)
//  {
//    return _cardListeners.add(listener);
//  }
//
//  public boolean removeCardListener(SetGameClientCardListener listener)
//  {
//    return _cardListeners.remove(listener);
//  }
//
//  private void fireCardEvent(CardEvent event)
//  {
//    if (_cardListeners != null)
//    {
//      for (int i = 0; i < _cardListeners.size(); i++)
//      {
//        SetGameClientCardListener cardListenerIF = (SetGameClientCardListener) _cardListeners.get(i);
//        cardListenerIF.notifyCardEvent(event);
//      }
//    }
//  }

  public String toString()
  {
    final StringBuffer buf = new StringBuffer("JSetCard:");
    buf.append(_properties);
    return buf.toString();
  }
}
