// START LICENSE
// JSet - a Java JSet card board game implementation
// Copyright (C) 2004 Jerome Lacoste
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// END LICENSE

package org.cb.jset;

import java.util.EventListener;

/**
 * Interface that Board listeners must implement.
 * <p>
 * FIXME introduce Events??..
 *
 * @author jerome@coffeebreaks.org - last modified by $LastChangedBy: jerome $
 * @version $Id: SetGameBoardListener.java 112 2004-04-14 22:25:52Z jerome $
 */
public interface SetGameBoardListener extends EventListener
{
  /**
   * Called to notify that the specified cards were added to the board.
   * @param cards the cards that were added to the board.
   */
  void cardsAdded(CardProperties[] cards);

  /**
   * Called to notify that the specified set was removed from the board.
   * The set should be a {@link CardSet#isMatching() matching set}.
   * @param set the set that was removed from the board
   */
  void setRemoved(CardSet set);
}
