// START LICENSE
// JSet - a Java JSet card board game implementation
// Copyright (C) 2004 Jerome Lacoste
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// END LICENSE

package org.cb.jset.client;

import org.cb.jset.CardSet;
import org.cb.jset.MatchingException;
import org.cb.jset.SetGameBoardListener;

/**
 * Interface to a game seen from a client.
 * <p>
 * In the design of the game, this interface effectively hides the locality
 * (game can be local or remote) and the {@link org.cb.jset.SetGameConnection} artifacts, used to
 * identify clients moves.
 *
 * @author jerome@coffeebreaks.org - last modified by $LastChangedBy: jerome $
 * @version $Id: SetGame.java 122 2004-04-14 23:29:10Z jerome $
 */
public interface SetGame
{
  void start();
  void stop();
  void endTurn();
  void removeSet(CardSet set) throws MatchingException;
  // void addPlayersListener(PlayersListenerIF)
  // void removePlayersListener(PlayersListenerIF)
  void addBoardListener(SetGameBoardListener listener);
  void removeBoardListener(SetGameBoardListener listener);
//  void addScoreListener(ScoreListenerIF listener);
//  void removeScoreListener(ScoreListenerIF listener);
  void addGameListener(SetGameListener listener);
  void removeGameListener(SetGameListener listener);
}
