// START LICENSE
// JSet - a Java JSet card board game implementation
// Copyright (C) 2004 Jerome Lacoste
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// END LICENSE

package org.cb.jset.client.model;

import org.cb.cardboard.Card;

import java.util.EventObject;

/**
 * Event related to the change of state of a card.
 *
 * @author jerome@coffeebreaks.org - last modified by $LastChangedBy: jerome $
 * @version $Id: CardEvent.java 123 2004-04-14 23:45:53Z jerome $
 */
public class CardEvent extends EventObject
{
  /** the type of a selection event. */
  public static final int SELECTED = 1;
  /** the type of a deselection event. */
  public static final int DESELECTED = 2;
  /**  the type of the event. */
  private final int _type;

  /**
   * Constructs an instance of <code>CardEvent</code>, given the specified source and type. 
   * @param source
   * @param type
   */
  public CardEvent(final Card source, final int type)
  {
    super(source);
    _type = type;
  }

  /**
   * @return the type of the event
   */
  public int getType()
  {
    return _type;
  }
}
