// START LICENSE
// JSet - a Java JSet card board game implementation
// Copyright (C) 2004 Jerome Lacoste
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// END LICENSE

package org.cb.jset.client.model;

import org.cb.jset.CardProperties;
import org.cb.jset.CardSet;
import org.cb.jset.BoardException;

/**
 * Interface that SetGameClientBoard implementations must inherit from.
 *
 * @author jerome@coffeebreaks.org - last modified by $LastModifiedBy$
 * @version $Id: SetGameClientBoard.java 119 2004-04-14 23:20:09Z jerome $
 */
public interface SetGameClientBoard
{
  /**
   * @return the number of cards on the board.
   */
  int getNbCards();
  /**
   * Add the specified cards onto the board.
   * @param cards the cards to add.
   * @throws NullPointerException if <code>cards</code> is <code>null</code> or if an element in the array is <code>null</code>.
   */
  void addCards(CardProperties[] cards);
  /**
   * Remove the specified matching set from the board.
   * @param set the set to remove
   * @throws BoardException when something fails
   */
  void removeSet(CardSet set) throws BoardException;
}
