// START LICENSE
// JSet - a Java JSet card board game implementation
// Copyright (C) 2004 Jerome Lacoste
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// END LICENSE

package org.cb.jset;

import junit.framework.*;

import java.util.*;



/**
 * Test the card stack
 * @author jerome@coffeebreaks.org - last modified by $Author: jerome $
 * @version $Id: CardStackTest.java 78 2004-04-13 04:25:57Z jerome $
 */
public class CardStackTest extends BaseTestCase
{
  private MatchingSetFinder mOUT;

  /** Creates a new instance of FlightTargetBO */
  public CardStackTest(final String testName)
  {
    super(testName);
  }

  protected void setUp()
  {
    mOUT = new MatchingSetFinder();
  }

  protected void tearDown()
  {
    mOUT = null;
  }

  public static void main(final String[] args)
  {
    junit.textui.TestRunner.run(suite());
  }

  public static Test suite()
  {
    final TestSuite suite = new TestSuite(CardStackTest.class);

    return suite;
  }

  public void testAllThere()
  {
    final Set set = new HashSet();
    final CardStack stack = new CardStack();
    stack.shuffle();

    while (stack.size() > 0)
    {
      final CardProperties[] cards = stack.pop(3);
      for (int i = 0; i < cards.length; i++)
      {
        final CardProperties card = cards[i];
        // System.out.println("Popped card:" + card);
        final boolean added = set.add(card);
        assertTrue("card didn't exist before:" + card, added);
      }
    }
  }
}
