// START LICENSE
// JSet - a Java JSet card board game implementation
// Copyright (C) 2004 Jerome Lacoste
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// END LICENSE

package org.cb.jset;

import junit.framework.*;

import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;



/**
 * Test the client board
 * @author jerome@coffeebreaks.org - last modified by $Author: jerome $
 * @version $Id: MatchingSetFinderTest.java 78 2004-04-13 04:25:57Z jerome $
 */
public class MatchingSetFinderTest extends org.cb.jset.BaseTestCase
{
  private MatchingSetFinder mOUT;

  /** Creates a new instance of FlightTargetBO */
  public MatchingSetFinderTest(final String testName)
  {
    super(testName);
  }

  protected void setUp()
  {
    mOUT = new MatchingSetFinder();
  }

  protected void tearDown()
  {
    mOUT = null;
  }

  public static void main(final String[] args)
  {
    junit.textui.TestRunner.run(suite());
  }

  public static Test suite()
  {
    final TestSuite suite = new TestSuite(MatchingSetFinderTest.class);

    return suite;
  }

  public void testCheckSpaces()
  {
    final List l = new ArrayList();
    l.add(new JSetCard(new CardProperties(1, 2, 3, 1))); // type, color, number, fill
    l.add(new JSetCard(new CardProperties(1, 1, 1, 2)));
    l.add(new JSetCard(new CardProperties(1, 1, 1, 1)));
    l.add(new JSetCard(new CardProperties(2, 3, 1, 1)));
    l.add(new JSetCard(new CardProperties(2, 1, 1, 2)));
    l.add(new JSetCard(new CardProperties(2, 2, 2, 1)));
    l.add(null);
    l.add(new JSetCard(new CardProperties(2, 3, 1, 3)));
    l.add(new JSetCard(new CardProperties(1, 2, 2, 1)));
    l.add(null);
    l.add(new JSetCard(new CardProperties(1, 1, 2, 3)));
    l.add(new JSetCard(new CardProperties(3, 1, 3, 1)));
    l.add(new JSetCard(new CardProperties(3, 3, 1, 3)));
    l.add(null);

    final CardSet[] foundSets = mOUT.findSets(l);

    System.out.println("Main: Found " + foundSets.length + " sets.");
    for (int i = 0; i < foundSets.length; i++)
    {
      System.out.println("Main: CardSet[" + i + "]:" + foundSets[i]);
    }
    assertEquals("correct number of sets found", 2, foundSets.length);
  }
}
